

#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#include <unistd.h>

#include "common.h"
#include "message.h"
#include "transfer.h"
#include "merge.h"
#include "stats.h"

    char *TS_Server= (char*)"localhost";
    int Port=10305;
    unsigned int TSstream = 1;

    extern int * StatsMem[NUMCOUNTERS];

    int Mode=3;

    int BufferSize=64*1024;
    int SndBufSize=512;
    int RcvBufSize=512;

    int  hdr[6];
    
//    FILE *OutStream;
//    char *FileName= (char*)"/tmp/merged.dat";

     char * OutputBuffer;
     ItDesc_Ptr OutputBufferPtr;
     int OutputBufferLen;

   void storage_init () {

          OutputBuffer = malloc(BufferSize + sizeof(HEADER));
          OutputBuffer += sizeof(HEADER);

          OutputBufferPtr = (ItDesc_Ptr) OutputBuffer;
          OutputBufferLen = 0;

//       OutStream = fopen(FileName,"w");
//       fclose(OutStream);

      sprintf(message_buffer,"Resetting communication with server %s\n",TS_Server);
      report_message(MSG_INFORMATION);

      (void) transferUseOverlap(0);
      (void) transferNice(1);
      (void) transferMultiBlockSize(TSstream, BufferSize);
      (void) transferMultiSndBufSize(TSstream, SndBufSize);
      (void) transferMultiRcvBufSize(TSstream, RcvBufSize);
      (void) transferMultiMode(TSstream, Mode);
      (void) transferMultiPort(TSstream, Port);
      (void) transferMultiInit(TSstream, TS_Server);

   }

   int do_storage (char * baseaddress, int len) {
       int rc;
       int i;

/*
       OutStream = fopen(FileName,"a");

    hdr[0] = 0x45594245;
    hdr[1] = 0x41544144;
    hdr[2] = 0;
    hdr[3] = 1;
    hdr[4] = 0x00010001;
    hdr[5] = len;

       rc = fwrite(&hdr[0],4,6,OutStream);         // header
       rc = fwrite(baseaddress,1,len,OutStream);   //   data 

    hdr[0] = 0xffffffff;
    hdr[1] = 0xffffffff;

       rc = fwrite(&hdr[0],4,2,OutStream);         // trailer

    hdr[0] = 0x5e5e5e5e;

      for (i=(len+24+8); i<BufferSize; i++) {
         rc = fwrite(&hdr[0],1,1,OutStream);       // padding
      }

       fclose(OutStream);

*/

       sprintf(message_buffer,"storage.c  sending to storage server  len=%i\n", len);
       report_message(MSG_TRACE);

      rc = transferMultiTxData (TSstream, baseaddress, TSstream, len);

      (*StatsMem[XFER])++;

       return rc;
   }
